class RS232
{
  public:
    RS232(uint32_t baudrate=115200)
    {
  	    //setzen der Baudrate:
	    UBRRH = (uint8_t) ((TAKTFREQUENZ/8/baudrate-1)>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
	    UBRRL = (uint8_t)  (TAKTFREQUENZ/8/baudrate-1);     //Setzen des LOW -Bytes des Baudraten-Registers
        //einfache (nicht doppelte) bertragungsgeschwindigkeit:
        UCSRA = (1<<U2X);
	    //Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
	    UCSRC = (1<<URSEL)|(1<<UCSZ1)|(1<<UCSZ0);
    }
    void start(bool senden, bool empfangen)
    {
        if(senden==true)
            UCSRB |= 1<<TXEN;
        if(empfangen==true)
            UCSRB |= 1<<RXEN;
    }
    void stop()
    {
            UCSRB &= 255 - (1<<TXEN) - (1<<RXEN);
    }
    void sendeZeichen(uint8_t zeichen)
    {
        while( !(UCSRA & (1<<UDRE)) ); //Warten bis der Uebertragungspuffer leer ist
        UDR = zeichen;                    //Daten in den Puffer schreiben und bertragen
    }
};
